]> arthur.barton.de Git - backup-script.git/blob - bin/backup-script
ff8ad47d089dcc8dcd6a3911422fc8e4c30a62b7
[backup-script.git] / bin / backup-script
1 #!/bin/bash
2 #
3 # backup-script system for cloning systems using rsync
4 # Copyright (c)2008-2011 Alexander Barton, alex@barton.de
5 #
6 # This program is free software; you can redistribute it and/or modify
7 # it under the terms of the GNU General Public License as published by
8 # the Free Software Foundation; either version 2 of the License, or
9 # (at your option) any later version.
10 # Please read the file COPYING, README and AUTHORS for more information.
11 #
12
13 NAME=`basename $0`
14 CONF_D="/etc/backup-script.d"
15 VERBOSE=0
16 PIDFILE="/var/run/$NAME.pid"
17
18 export LC_ALL=C
19
20 declare -i count_all=0
21 declare -i count_started=0
22 declare -i count_ok=0
23 declare -i count_ok_vanished=0
24
25 destinations=""
26 pre_exec=""
27 post_exec=""
28
29 if [ "$1" == "-p" ]; then
30         VERBOSE=1
31         shift
32 fi
33
34 if [ $# -gt 1 ]; then
35         echo "Usage: $NAME [-p] [<system>]"
36         exit 1
37 fi
38
39 Log() {
40         logger -t "$NAME" "$*"
41 }
42
43 Message() {
44         echo "$*"
45 }
46
47 MessageLog() {
48         Log "$*"
49         Message "$*"
50 }
51
52 CleanUp() {
53         if [ -n "$post_exec" ]; then
54                 echo "Executing \"$post_exec\" ..."
55                 sh -c $post_exec
56                 if [ $? -ne 0 ]; then
57                         echo "Warning: post-exec command failed!"
58                 fi
59                 echo
60         fi
61         rm -f "$PIDFILE"
62 }
63
64 GotSignal() {
65         echo
66         echo "--> Got break signal, cleaning up & aborting ..."
67         echo
68         CleanUp
69         echo -n "Aborted: "; date
70         echo
71         exit 9
72 }
73
74 if [ $# -ge 1 ]; then
75         sys=${CONF_D}/$1
76         if [ ! -r "$sys" ]; then
77                 echo "$NAME: Can' read \"$sys\"!"
78                 exit 1
79         fi
80 else
81         sys=${CONF_D}/*
82 fi
83
84 trap GotSignal SIGINT
85
86 Log "Started ..."
87
88 echo -n "Started: "; date
89 echo
90
91 [ -r "${CONF_D}/backup-script.conf" ] && source "${CONF_D}/backup-script.conf"
92
93 # check and create PID file
94 if [ -e "$PIDFILE" ]; then
95         Log "Lockfile \"$PIDFILE\" already exists. Aborting!"
96         echo "Lockfile \"$PIDFILE\" already exists."
97         echo "Is an other instance still running?"
98         echo
99         echo -n "Aborted: "; date
100         echo
101         exit 3
102 fi
103 touch "$PIDFILE" 2>/dev/null
104 if [ $? -ne 0 ]; then
105         echo "Warning: can't create PID file \"$PIDFILE\"!"
106         echo
107 else
108         echo "$$" >>"$PIDFILE"
109 fi
110
111 if [ -n "$pre_exec" ]; then
112         echo "Executing \"$pre_exec\" ..."
113         sh -c $pre_exec
114         if [ $? -ne 0 ]; then
115                 echo "Error: pre-exec command failed!"; echo
116                 CleanUp
117                 echo "Aborting backup."; echo
118                 exit 2
119         fi
120         sleep 2
121         echo
122 fi
123
124 for f in $sys; do
125         [ -r "$f" -a -f "$f" ] || continue
126
127         system=`basename $f`
128         user="root"
129         target=""
130         rsync_args_add=""
131         compress=1
132         local=0
133
134         case "$system" in
135                 "backup-script.conf"|*.sh)
136                         continue
137                         ;;
138         esac
139
140         # Read in configuration file
141         source "$f"
142
143         [ "$local" -eq 0 ] \
144                 && MessageLog "Working on \"$system\" ..." \
145                 || MessageLog "Working on \"$system\" (local system) ..."
146
147         count_all=$count_all+1
148
149         # Check target directory
150         if [ -z "$target" ]; then
151                 MessageLog "No target directory specified for \"$system\"!? Skipped."
152                 echo; continue
153         fi
154         if [ ! -d "$target" ]; then
155                 MessageLog "Target \"$target\" is not a directory!? \"$system\" skipped."
156                 echo; continue
157         fi
158
159         destdir="$target"
160         target="$target/$system"
161         mkdir -p "$target"
162
163         if [ "$local" -eq 0 ]; then
164                 # Check if system is alive
165                 ping -c 1 "$system" >/dev/null 2>&1
166                 if [ $? -ne 0 ]; then
167                         MessageLog "Host \"$system\" seems not to be alive!? Skipped."
168                         echo; continue
169                 fi
170                 Message "OK, host \"$system\" seems to be alive."
171         fi
172
173         cmd="rsync --archive"
174         [ "$compress" -ne 0 ] && cmd="$cmd --compress"
175         cmd="$cmd --rsh=ssh --delete --delete-excluded --sparse"
176         [ "$VERBOSE" -gt 0 ] && cmd="$cmd --progress"
177         cmd="$cmd --exclude=/BACKUP --exclude=/backup --exclude=/mnt"
178         cmd="$cmd --exclude=/dev --exclude=/proc --exclude=/sys"
179         cmd="$cmd --exclude=/usr/src --exclude=/usr/local/src"
180         cmd="$cmd --exclude=/var/cache/apt --exclude=/var/amavis/blocked"
181         cmd="$cmd --exclude=/var/log --exclude=/tmp --exclude=/var/tmp"
182         [ -n "$rsync_args_add" ] && cmd="$cmd $rsync_args_add"
183
184         [ "$local" -eq 0 ] \
185                 && cmd="$cmd ${user}@${system}:/ $target" \
186                 || cmd="$cmd / $target"
187
188         Message "Calling: $cmd"
189         echo -n "Start date: "; date
190         count_started=$count_started+1
191         rm -f "$target/.stamp"
192         
193         $cmd; ret=$?
194         echo "code=$ret" >"$target/.stamp"
195
196         if [ $ret -eq 20 ]; then
197                 MessageLog "Backup of \"$system\" interrupted. Aborting ..."
198                 CleanUp
199                 exit 1
200         fi
201
202         if [ $ret -eq 0 -o $ret -eq 24 ]; then
203                 [ $ret -eq 24 ] && count_ok_vanished=$count_ok_vanished+1
204
205                 MessageLog "System \"$system\" completed with status $ret, OK."
206                 count_ok=$count_ok+1
207         else
208                 MessageLog "System \"$system\" completed with ERRORS, code $ret!"
209         fi
210         echo -n "End date: "; date
211
212         destinations="$destinations $destdir"
213         echo
214 done
215
216 sync
217
218 Log "Done: $count_all jobs, $count_started started, $count_ok completed without errors."
219
220 paths=$( echo $destinations | sed -e 's/ /\n/g' | sort | uniq )
221 if [ -n "$paths" ]; then
222         df -h $paths
223         echo
224 fi
225
226 CleanUp
227
228 echo -n "Done: "; date
229 echo
230 echo " - $count_all jobs defined,"
231 echo " - $count_started jobs started,"
232 echo " - $count_ok done without errors."
233 echo
234
235 if [ $count_started -ne $count_ok ]; then
236         echo "----->  THERE HAVE BEEN ERRORS!  <-----"
237         echo
238 fi
239
240 # -eof-